import React from 'react';
import { IPros as PortalProps } from '../portal';
export interface IProps extends PortalProps {
    visible: boolean;
    maskVisible?: boolean;
    maskCloseable?: boolean;
    escCloseable?: boolean;
    motionClassName?: string;
    motionDuration?: number;
    maskClassName?: string;
    maskStyle?: React.CSSProperties;
    wrapClassName?: string;
    needWrap?: boolean;
    getContainer?: () => HTMLElement | false;
    onClose?: () => void;
    children: (status: string) => React.ReactNode;
}
interface IState {
    visible: boolean;
    status: string;
    elementReady: boolean;
}
interface IBodyStyle {
    origin: React.CSSProperties;
    locked: React.CSSProperties;
}
export default class Dialog extends React.Component<IProps, IState> {
    static defaultProps: {
        getContainer: () => HTMLElement;
        needWrap: boolean;
    };
    bodyStyle: IBodyStyle;
    id: string;
    outer: string;
    inited: boolean;
    hideByOtherDialog: boolean;
    statusQueue: Array<string>;
    constructor(props: IProps);
    initBodyStyle: () => void;
    initEvent: () => void;
    setOuter: (outer?: string | undefined) => void;
    getCurrentContainer: () => false | HTMLElement | undefined;
    needHideOuterModal: () => void;
    needShowOuterModal: () => void;
    init: () => void;
    private hide;
    private show;
    clearEvent: () => void;
    componentDidMount(): void;
    componentDidUpdate(prevProps: IProps): void;
    componentWillUnmount(): void;
    setCurrentOpenModal: (id: string) => void;
    switchVisible: (visible: boolean) => void;
    toggleBodyLock: (lock: boolean) => void;
    handlePortalRendered: () => void;
    close: () => void;
    handleMaskClick: () => void;
    handleKeyDown: (e: KeyboardEvent) => void;
    setStatus: (status?: string | undefined) => void;
    handleStatusChange: (status: string) => void;
    handleLeaveEnd: () => void;
    renderContent: (child: React.ReactNode, restStyle: React.CSSProperties) => JSX.Element;
    render(): JSX.Element;
}
export {};
