"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable import/prefer-default-export */
var react_dom_1 = __importDefault(require("react-dom"));
var constant_1 = require("./constant");
function getClassName(subName, options) {
    var classNames = [];
    if (Array.isArray(subName)) {
        classNames = subName.reduce(function (arr, name) {
            var next = __spreadArrays(arr);
            if (name) {
                if (typeof name === 'string') {
                    next.push(constant_1.CLASSNAME_PREFIX + "-" + name);
                }
                else if (typeof name === 'object') {
                    Object.keys(name).forEach(function (key) {
                        if (name[key]) {
                            next.push(constant_1.CLASSNAME_PREFIX + "-" + key);
                        }
                    });
                }
            }
            return next;
        }, []);
    }
    else {
        classNames = [constant_1.CLASSNAME_PREFIX + "-" + subName];
    }
    if (options) {
        if (options.visible != null && !options.visible) {
            classNames.push(constant_1.CLASSNAME_PREFIX + "-hide");
        }
    }
    return classNames.join(' ');
}
exports.getClassName = getClassName;
function reactVersionLimit() {
    if (!react_dom_1.default.createPortal) {
        // eslint-disable-next-line no-throw-literal
        throw 'React version number must be greater than 16.0.0';
    }
}
exports.reactVersionLimit = reactVersionLimit;
//# sourceMappingURL=helper.js.map