"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_dom_1 = require("react-dom");
var Portal = /** @class */ (function (_super) {
    __extends(Portal, _super);
    function Portal(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            renderable: false,
        };
        _this.mountHook = function () {
            var onPortalRendered = _this.props.onPortalRendered;
            if (onPortalRendered) {
                onPortalRendered();
            }
        };
        _this.renderContent = function () {
            var _a = _this.props, children = _a.children, style = _a.style, className = _a.className;
            return (react_1.default.createElement("div", { style: style, className: className }, children));
        };
        if (props.visible) {
            _this.state = {
                renderable: true,
            };
        }
        return _this;
    }
    Portal.prototype.componentDidMount = function () {
        if (this.state.renderable) {
            this.mountHook();
        }
    };
    Portal.prototype.componentDidUpdate = function (prevProps) {
        var _this = this;
        if (this.props.visible && !prevProps.visible && !this.state.renderable) {
            this.setState({
                renderable: true,
            }, function () {
                _this.mountHook();
            });
        }
    };
    Portal.prototype.render = function () {
        var _a = this.props, _b = _a.container, container = _b === void 0 ? document.body : _b, children = _a.children;
        if (!this.state.renderable) {
            return null;
        }
        if (container === false) {
            return react_1.default.createElement(react_1.default.Fragment, null, children);
        }
        var Content = this.renderContent();
        return react_dom_1.createPortal(Content, container);
    };
    Portal.defaultProps = {
        visible: false,
        container: document.body,
    };
    return Portal;
}(react_1.default.Component));
exports.default = Portal;
//# sourceMappingURL=index.js.map