import React, { Component } from 'react';
import './style/index.scss';
export declare type ButtonType = 'default' | 'standard' | 'confirm' | 'danger' | 'warning' | 'link';
export declare type ButtonSize = 'small' | 'default' | 'medium' | 'large';
export declare type ButtonHtmlType = 'button' | 'reset' | 'submit';
interface ButtonProps {
    type?: ButtonType;
    size?: ButtonSize;
    /** 是否为空心按钮 */
    empty?: boolean;
    /** 设置 `button` 原生的 `type` 值，可选值请参考 [HTML 标准](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-type) */
    htmlType?: ButtonHtmlType;
    /** 自定义样式类名 */
    className?: string;
    grouped?: boolean;
    /** 是否不可用 */
    disabled?: boolean;
    /** 按钮左侧是否增加加载状态icon */
    loading?: boolean;
    leftIcon?: React.ReactNode;
    rightIcon?: React.ReactNode;
    getLoadingIcon?: Function;
    showChildrenWhenLoading?: boolean;
    onClick?: () => void;
}
/**
 * @example ./doc/button.md
 */
declare class Button extends Component<ButtonProps> {
    static defaultProps: {
        htmlType: string;
        empty: boolean;
        size: string;
        type: string;
        grouped: boolean;
        disabled: boolean;
        loading: boolean;
        className: string;
    };
    static setDefaultConfig: (config?: {}) => void;
    static Group: React.ReactNode;
    handleClick: () => void;
    renderLeftIcon(leftIcon: React.ReactNode, loading?: boolean): any;
    shouldRenderChildren: () => boolean | undefined;
    renderChildren: () => React.ReactNode;
    render(): JSX.Element;
}
export default Button;
