"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var prop_types_1 = __importDefault(require("prop-types"));
var classnames_1 = __importDefault(require("classnames"));
var rc_checkbox_1 = __importDefault(require("rc-checkbox"));
var shallowequal_1 = __importDefault(require("shallowequal"));
var config_context_1 = require("../config-context");
var warning_1 = __importDefault(require("../_util/warning"));
var Check_1 = __importDefault(require("../icons/Check"));
var Minus_1 = __importDefault(require("../icons/Minus"));
var Checkbox = /** @class */ (function (_super) {
    __extends(Checkbox, _super);
    function Checkbox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.saveCheckbox = function (node) {
            _this.rcCheckbox = node;
        };
        _this.renderCheckbox = function (_a) {
            var _b, _c;
            var getPrefixCls = _a.getPrefixCls;
            var _d = _this, props = _d.props, context = _d.context;
            var customizePrefixCls = props.prefixCls, className = props.className, children = props.children, indeterminate = props.indeterminate, style = props.style, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave, restProps = __rest(props, ["prefixCls", "className", "children", "indeterminate", "style", "onMouseEnter", "onMouseLeave"]);
            var checkboxGroup = context.checkboxGroup;
            var prefixCls = getPrefixCls('checkbox', customizePrefixCls);
            var checkboxProps = __assign({}, restProps);
            if (checkboxGroup) {
                checkboxProps.onChange = function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    if (restProps.onChange) {
                        restProps.onChange.apply(restProps, args);
                    }
                    checkboxGroup.toggleOption({ label: children, value: props.value });
                };
                checkboxProps.name = checkboxGroup.name;
                checkboxProps.checked = checkboxGroup.value.indexOf(props.value) !== -1;
                checkboxProps.disabled = props.disabled || checkboxGroup.disabled;
            }
            var classString = classnames_1.default(className, (_b = {},
                _b[prefixCls + "-wrapper"] = true,
                _b[prefixCls + "-wrapper-checked"] = checkboxProps.checked,
                _b[prefixCls + "-wrapper-disabled"] = checkboxProps.disabled,
                _b));
            var checkboxClass = classnames_1.default((_c = {},
                _c[prefixCls + "-indeterminate"] = indeterminate,
                _c));
            return (
            // eslint-disable-next-line jsx-a11y/label-has-associated-control
            react_1.default.createElement("label", { className: classString, style: style, onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave },
                react_1.default.createElement("div", { className: prefixCls + "-box" },
                    react_1.default.createElement(rc_checkbox_1.default, __assign({}, checkboxProps, { prefixCls: prefixCls, className: checkboxClass, ref: _this.saveCheckbox })),
                    react_1.default.createElement("b", { className: prefixCls + "-check-icon" }, indeterminate ? react_1.default.createElement(Minus_1.default, null) : react_1.default.createElement(Check_1.default, null))),
                children !== undefined && react_1.default.createElement("span", null, children)));
        };
        return _this;
    }
    Checkbox.prototype.componentDidMount = function () {
        var value = this.props.value;
        var _a = (this.context || {}).checkboxGroup, checkboxGroup = _a === void 0 ? {} : _a;
        if (checkboxGroup.registerValue) {
            checkboxGroup.registerValue(value);
        }
        warning_1.default('checked' in this.props || (this.context || {}).checkboxGroup || !('value' in this.props), 'Checkbox', '`value` is not validate prop, do you mean `checked`?');
    };
    Checkbox.prototype.shouldComponentUpdate = function (nextProps, nextState, nextContext) {
        return (!shallowequal_1.default(this.props, nextProps) ||
            !shallowequal_1.default(this.state, nextState) ||
            !shallowequal_1.default(this.context.checkboxGroup, nextContext.checkboxGroup));
    };
    Checkbox.prototype.componentDidUpdate = function (_a) {
        var prevValue = _a.value;
        var value = this.props.value;
        var _b = (this.context || {}).checkboxGroup, checkboxGroup = _b === void 0 ? {} : _b;
        if (value !== prevValue && checkboxGroup.registerValue && checkboxGroup.cancelValue) {
            checkboxGroup.cancelValue(prevValue);
            checkboxGroup.registerValue(value);
        }
    };
    Checkbox.prototype.componentWillUnmount = function () {
        var value = this.props.value;
        var _a = (this.context || {}).checkboxGroup, checkboxGroup = _a === void 0 ? {} : _a;
        if (checkboxGroup.cancelValue) {
            checkboxGroup.cancelValue(value);
        }
    };
    Checkbox.prototype.focus = function () {
        this.rcCheckbox.focus();
    };
    Checkbox.prototype.blur = function () {
        this.rcCheckbox.blur();
    };
    Checkbox.prototype.render = function () {
        return react_1.default.createElement(config_context_1.ConfigConsumer, null, this.renderCheckbox);
    };
    Checkbox.defaultProps = {
        indeterminate: false,
    };
    Checkbox.contextTypes = {
        checkboxGroup: prop_types_1.default.any,
    };
    return Checkbox;
}(react_1.default.Component));
exports.default = Checkbox;
//# sourceMappingURL=Checkbox.js.map