"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable react/jsx-no-bind */
var react_1 = __importStar(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var dayjs_1 = __importDefault(require("dayjs"));
var helper_1 = require("../../_base/helper");
var header_1 = __importDefault(require("./header"));
var body_1 = __importDefault(require("./body"));
var footer_1 = __importDefault(require("./footer"));
var panelType_1 = __importDefault(require("./panelType"));
function DatePanel(props) {
    var _a;
    var className = props.className, dataPlacement = props.dataPlacement, value = props.value, langData = props.langData, _b = props.type, type = _b === void 0 ? 'date' : _b, onChange = props.onChange, onOk = props.onOk, others = __rest(props, ["className", "dataPlacement", "value", "langData", "type", "onChange", "onOk"]);
    var defaultType = panelType_1.default[type] == null ? panelType_1.default.date : panelType_1.default[type];
    var onlyPickerTime = defaultType === panelType_1.default.time;
    var _c = react_1.useState(defaultType), currentType = _c[0], setCurrentType = _c[1];
    var _d = react_1.useState(dayjs_1.default(value)), showDate = _d[0], setShowDate = _d[1];
    react_1.useEffect(function () {
        setShowDate(dayjs_1.default(value));
    }, [value]);
    react_1.useEffect(function () {
        var next = panelType_1.default[type];
        setCurrentType(next == null ? panelType_1.default.date : next);
    }, [type]);
    var wrapClassName = classnames_1.default(helper_1.getClassName([
        'date-picker-panel-wrap',
        (_a = {}, _a["date-picker-panel-" + dataPlacement] = dataPlacement, _a),
    ]), className);
    var handleYearChange = function (isAdd) {
        var next = showDate;
        var step = currentType === panelType_1.default.year ? 10 : 1;
        if (isAdd) {
            next = showDate.add(step, 'year');
        }
        else {
            next = showDate.subtract(step, 'year');
        }
        setShowDate(next);
    };
    var handleMonthChange = function (isAdd) {
        var next = showDate;
        if (isAdd) {
            next = showDate.add(1, 'month');
        }
        else {
            next = showDate.subtract(1, 'month');
        }
        setShowDate(next);
    };
    var changeCurrentType = function (nextType) {
        setCurrentType(nextType);
    };
    var handleChange = function (nextValue, needClose) {
        if (needClose === void 0) { needClose = false; }
        if (defaultType === panelType_1.default.dateTime) {
            onChange(nextValue, needClose);
            if (currentType > panelType_1.default.dateTime) {
                changeCurrentType(defaultType);
            }
        }
        else if (currentType === defaultType) {
            onChange(nextValue, currentType !== panelType_1.default.time);
        }
        else {
            setShowDate(nextValue);
            changeCurrentType(defaultType);
        }
    };
    var commonProps = {
        type: currentType,
        langData: langData,
        current: showDate,
    };
    return (react_1.default.createElement("div", { className: wrapClassName },
        !onlyPickerTime && (react_1.default.createElement(header_1.default, __assign({}, commonProps, { onYearChange: handleYearChange, onMonthChange: handleMonthChange, onSelectMonth: changeCurrentType.bind(null, panelType_1.default.month), onSelectYear: changeCurrentType.bind(null, panelType_1.default.year) }))),
        react_1.default.createElement(body_1.default, __assign({}, commonProps, others, { onChange: handleChange, largePanel: onlyPickerTime })),
        react_1.default.createElement(footer_1.default, __assign({}, commonProps, { onChange: handleChange, onOk: onOk, onlyPickerTime: onlyPickerTime, onPanelTypeChange: setCurrentType }))));
}
exports.default = DatePanel;
//# sourceMappingURL=date.js.map