"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var dayjs_1 = __importDefault(require("dayjs"));
var calculate_1 = require("../utils/calculate");
var helper_1 = require("../../_base/helper");
function DateBody(props) {
    var current = props.current, langData = props.langData, disableDate = props.disableDate, onChange = props.onChange;
    var list = calculate_1.getDateList(current, disableDate);
    var handleClick = function (dateNode) {
        if (!dateNode.disabled) {
            onChange(dayjs_1.default(dateNode.value)
                .hour(current.hour())
                .minute(current.minute())
                .second(current.second()));
        }
    };
    return (react_1.default.createElement("ul", { className: helper_1.getClassName('date-picker-body-wrap') },
        langData.text.weekDays.map(function (text) { return (react_1.default.createElement("li", { key: "week-" + text, className: helper_1.getClassName(['date-picker-body-item', 'date-picker-body-title']) }, text)); }),
        list.map(function (item) { return (react_1.default.createElement("li", { key: item.value, onClick: handleClick.bind(null, item), className: helper_1.getClassName([
                'date-picker-body-item',
                { 'date-picker-body-item-out': item.out },
                { 'date-picker-body-item-is-current': item.isCurrent },
                { 'date-picker-body-item-disabled': item.disabled },
                { 'date-picker-body-item-checked': item.checked },
            ]) }, item.text)); })));
}
exports.default = DateBody;
//# sourceMappingURL=dateBody.js.map