"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var dayjs_1 = __importDefault(require("dayjs"));
var helper_1 = require("../../_base/helper");
var button_1 = __importDefault(require("../../button"));
var panelType_1 = __importDefault(require("./panelType"));
function PanelFooter(props) {
    var type = props.type, langData = props.langData, onChange = props.onChange, onPanelTypeChange = props.onPanelTypeChange, onOk = props.onOk, onlyPickerTime = props.onlyPickerTime;
    var isSelectTime = type === panelType_1.default.time;
    var setValue = function (isToDay) {
        var now = dayjs_1.default();
        if (isToDay) {
            onChange(now.startOf('d'), true);
        }
        else {
            onChange(now, true);
        }
    };
    var changePanelType = function () {
        var next = isSelectTime ? panelType_1.default.dateTime : panelType_1.default.time;
        onPanelTypeChange(next);
    };
    var content = null;
    if (type > panelType_1.default.dateTime) {
        return null;
    }
    if (type === panelType_1.default.date) {
        content = react_1.default.createElement("a", { onClick: setValue.bind(null, true) }, langData.text.today);
    }
    else if (type <= panelType_1.default.dateTime) {
        content = (react_1.default.createElement("div", { className: helper_1.getClassName('date-time-picker-footer') },
            react_1.default.createElement("a", { onClick: setValue.bind(null, false) }, langData.text.now),
            react_1.default.createElement("span", { className: helper_1.getClassName('right-wrap') },
                !onlyPickerTime && (react_1.default.createElement("a", { onClick: changePanelType }, isSelectTime ? langData.text.selectDate : langData.text.selectTime)),
                react_1.default.createElement(button_1.default, { onClick: onOk, size: "small" }, langData.text.ok))));
    }
    return react_1.default.createElement("div", { className: helper_1.getClassName('date-picker-footer') }, content);
}
exports.default = PanelFooter;
//# sourceMappingURL=footer.js.map