"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var calculate_1 = require("../utils/calculate");
var helper_1 = require("../../_base/helper");
function MonthBody(props) {
    var current = props.current, langData = props.langData, onChange = props.onChange;
    var list = calculate_1.getMonthList(current, langData);
    var handleClick = function (dateNode) {
        if (!dateNode.disabled) {
            onChange(current.month(dateNode.value));
        }
    };
    return (react_1.default.createElement("ul", { className: helper_1.getClassName('date-picker-body-wrap') }, list.map(function (item) { return (react_1.default.createElement("li", { key: item.value, onClick: handleClick.bind(null, item), className: helper_1.getClassName([
            'date-picker-body-item',
            'date-picker-body-month-item',
            { 'date-picker-body-item-disabled': item.disabled },
            { 'date-picker-body-item-checked': item.checked },
        ]) }, item.text)); })));
}
exports.default = MonthBody;
//# sourceMappingURL=monthBody.js.map