import React from 'react';
import SearchInput from './SearchInput';
import { ConfigConsumerProps } from '../config-context';
declare const Placements: ["topLeft", "topCenter", "topRight", "bottomLeft", "bottomCenter", "bottomRight"];
declare type Placement = typeof Placements[number];
declare type MenuFunc = () => React.ReactNode;
declare type MenuItem = {
    label: string;
    value: any;
    key?: string | number;
};
export interface BasicDropDownProps {
    trigger?: 'click' | 'hover';
    menu: React.ReactNode | MenuFunc;
    options?: MenuItem[];
    onVisibleChange?: (visible: boolean) => void;
    visible?: boolean;
    disabled?: boolean;
    getPopupContainer?: (triggerNode: HTMLElement) => HTMLElement;
    prefixCls?: string;
    className?: string;
    transitionName?: string;
    placement?: Placement;
    menuClassName?: string;
    menuStyle?: React.CSSProperties;
    forceRender?: boolean;
    mouseEnterDelay?: number;
    mouseLeaveDelay?: number;
    openClassName?: string;
    searchable?: boolean;
    searchPlaceholder?: string;
    onSearch?: () => void;
    clearable?: boolean;
    onClear?: () => void;
}
/**
 * @example ./doc/dropdown.md
 */
export default class BasicDropdown extends React.Component<BasicDropDownProps, any> {
    static defaultProps: {
        mouseEnterDelay: number;
        mouseLeaveDelay: number;
        placement: "topLeft" | "topCenter" | "topRight" | "bottomLeft" | "bottomCenter" | "bottomRight";
    };
    searchInputRef: React.RefObject<SearchInput>;
    getTransitionName(): string;
    renderMenu: () => React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>;
    renderTrigger: (prefixCls: string) => React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>;
    renderDropDown: ({ getPopupContainer: getContextPopupContainer, getPrefixCls, }: ConfigConsumerProps) => JSX.Element;
    render(): JSX.Element;
}
export {};
