"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var rc_dropdown_1 = __importDefault(require("rc-dropdown"));
var classnames_1 = __importDefault(require("classnames"));
var SearchInput_1 = __importDefault(require("./SearchInput"));
var ClearanceOption_1 = __importDefault(require("./ClearanceOption"));
var config_context_1 = require("../config-context");
var types_1 = require("../_util/types");
var Placements = types_1.tuple('topLeft', 'topCenter', 'topRight', 'bottomLeft', 'bottomCenter', 'bottomRight');
/**
 * @example ./doc/dropdown.md
 */
var BasicDropdown = /** @class */ (function (_super) {
    __extends(BasicDropdown, _super);
    function BasicDropdown() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.searchInputRef = react_1.default.createRef();
        _this.renderMenu = function () {
            // rc-dropdown already can process the function of menu, but we have check logic here.
            // So we need render the element to check and pass back to rc-dropdown.
            var _a = _this.props, menu = _a.menu, searchable = _a.searchable, searchPlaceholder = _a.searchPlaceholder, clearable = _a.clearable, onSearch = _a.onSearch, onClear = _a.onClear;
            var menuNode;
            if (typeof menu === 'function') {
                menuNode = menu();
            }
            else {
                menuNode = menu;
            }
            menuNode = react_1.default.Children.only(menuNode);
            return (react_1.default.createElement("div", null,
                searchable && (react_1.default.createElement("div", { onClick: function (e) { return e.stopPropagation(); } },
                    react_1.default.createElement(SearchInput_1.default, { ref: _this.searchInputRef, placeholder: searchPlaceholder, onSearch: onSearch }))),
                clearable && react_1.default.createElement(ClearanceOption_1.default, { onClear: onClear }),
                menuNode));
        };
        _this.renderTrigger = function (prefixCls) {
            var _a;
            var _b = _this.props, children = _b.children, disabled = _b.disabled;
            var child = react_1.default.Children.only(children);
            var dropdownTrigger = react_1.default.cloneElement(child, {
                className: classnames_1.default(child.props.className, prefixCls + "-trigger-wrapper", (_a = {},
                    _a[prefixCls + "-disabled"] = disabled,
                    _a)),
                disabled: disabled,
            });
            return dropdownTrigger;
        };
        _this.renderDropDown = function (_a) {
            var getContextPopupContainer = _a.getPopupContainer, getPrefixCls = _a.getPrefixCls;
            var _b = _this.props, customizePrefixCls = _b.prefixCls, 
            // children,
            trigger = _b.trigger, disabled = _b.disabled, getPopupContainer = _b.getPopupContainer;
            var prefixCls = getPrefixCls('dropdown', customizePrefixCls);
            var triggerActions = disabled ? [] : [trigger];
            return (react_1.default.createElement(rc_dropdown_1.default, __assign({}, _this.props, { prefixCls: prefixCls, getPopupContainer: getPopupContainer || getContextPopupContainer, transitionName: _this.getTransitionName(), trigger: triggerActions, overlay: function () { return _this.renderMenu(); } }), _this.renderTrigger(prefixCls)));
        };
        return _this;
    }
    BasicDropdown.prototype.getTransitionName = function () {
        var _a = this.props, _b = _a.placement, placement = _b === void 0 ? '' : _b, transitionName = _a.transitionName;
        if (transitionName !== undefined) {
            return transitionName;
        }
        if (placement.indexOf('top') >= 0) {
            return 'slide-down';
        }
        return 'slide-up';
    };
    BasicDropdown.prototype.render = function () {
        return react_1.default.createElement(config_context_1.ConfigConsumer, null, this.renderDropDown);
    };
    BasicDropdown.defaultProps = {
        mouseEnterDelay: 0.15,
        mouseLeaveDelay: 0.1,
        placement: 'bottomLeft',
    };
    return BasicDropdown;
}(react_1.default.Component));
exports.default = BasicDropdown;
//# sourceMappingURL=BasicDropdown.js.map