/// <reference types="lodash" />
import React, { ReactNode, RefObject } from 'react';
import { Option, DropdownHOCProps, CommonDropdownProps, LazyLoadContainerProps, TriggerProps, FocusBy } from './interfaces';
export interface DropdownProps extends CommonDropdownProps, TriggerProps, LazyLoadContainerProps {
    selected: Option[];
    filteredOptions: Option[] | null;
    triggerActions?: string[];
    focusIndex: number;
    setFocusIndex: (index: number) => void;
    focusBy: FocusBy;
    setFocusBy: (by: string) => void;
    disableMouseFocus: boolean;
    setDisableMouseFocus: (flag: boolean) => void;
    onSearch: (val: string) => void;
    onSelect: (opt: Option, e: React.MouseEvent) => void;
    selectedIndex: (opt: Option) => number;
    onKeyDown: (e: React.KeyboardEvent<HTMLElement>) => void;
    menuPosition: string;
    adjustPopoverPosition: (trigger: RefObject<any>, menu: RefObject<any>) => EventListenerOrEventListenerObject;
    renderEmpty: () => ReactNode;
}
declare const _default: {
    new (props: Readonly<DropdownHOCProps>): {
        state: {
            selected: never[];
            visible: boolean;
            focusIndex: number;
            filteredOptions: null;
            menuPosition: string;
        };
        isControlled: boolean;
        disableMouseFocus: boolean;
        focusBy: FocusBy;
        hocRef: any;
        componentDidUpdate(): void;
        adjustPopoverPosition: (trigger: React.RefObject<any>, menu: React.RefObject<any>) => (() => void) & import("lodash").Cancelable;
        handleVisibleChange: (visible: boolean) => void;
        isVisible: () => boolean | undefined;
        getTransitionName: () => string | undefined;
        selectedIndex: (option: Option) => number;
        handleSelect: (option: Option, e: React.MouseEvent<Element, MouseEvent> | React.KeyboardEvent<Element>) => void;
        getSelected: () => never[];
        defaultSearch: (val: string, options: Option[]) => Option[];
        handleSearch: (val: string) => void;
        handleClear: () => void;
        handleKeyDown: (e: React.KeyboardEvent<Element>) => void;
        onDownArrow: () => void;
        onUpArrow: () => void;
        onReturn: (e: React.KeyboardEvent<Element>) => void;
        setFocusIndex: (index: number) => void;
        setFocusBy: (by: string) => void;
        setDisableMouseFocus: (flag: boolean) => void;
        open: () => void;
        close: () => void;
        renderEmpty: () => React.ReactNode;
        renderDropDown: ({ getPopupContainer: getContextPopupContainer, getPrefixCls, }: import("../config-context").ConfigConsumerProps) => JSX.Element;
        render(): JSX.Element;
        context: any;
        setState<K extends "visible" | "filteredOptions" | "selected" | "focusIndex" | "menuPosition">(state: import("./interfaces").DropdownHOCState | ((prevState: Readonly<import("./interfaces").DropdownHOCState>, props: Readonly<DropdownHOCProps>) => import("./interfaces").DropdownHOCState | Pick<import("./interfaces").DropdownHOCState, K> | null) | Pick<import("./interfaces").DropdownHOCState, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<DropdownHOCProps> & Readonly<{
            children?: React.ReactNode;
        }>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<DropdownHOCProps>, nextState: Readonly<import("./interfaces").DropdownHOCState>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<DropdownHOCProps>, prevState: Readonly<import("./interfaces").DropdownHOCState>): any;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<DropdownHOCProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<DropdownHOCProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<DropdownHOCProps>, nextState: Readonly<import("./interfaces").DropdownHOCState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<DropdownHOCProps>, nextState: Readonly<import("./interfaces").DropdownHOCState>, nextContext: any): void;
    };
    new (props: DropdownHOCProps, context?: any): {
        state: {
            selected: never[];
            visible: boolean;
            focusIndex: number;
            filteredOptions: null;
            menuPosition: string;
        };
        isControlled: boolean;
        disableMouseFocus: boolean;
        focusBy: FocusBy;
        hocRef: any;
        componentDidUpdate(): void;
        adjustPopoverPosition: (trigger: React.RefObject<any>, menu: React.RefObject<any>) => (() => void) & import("lodash").Cancelable;
        handleVisibleChange: (visible: boolean) => void;
        isVisible: () => boolean | undefined;
        getTransitionName: () => string | undefined;
        selectedIndex: (option: Option) => number;
        handleSelect: (option: Option, e: React.MouseEvent<Element, MouseEvent> | React.KeyboardEvent<Element>) => void;
        getSelected: () => never[];
        defaultSearch: (val: string, options: Option[]) => Option[];
        handleSearch: (val: string) => void;
        handleClear: () => void;
        handleKeyDown: (e: React.KeyboardEvent<Element>) => void;
        onDownArrow: () => void;
        onUpArrow: () => void;
        onReturn: (e: React.KeyboardEvent<Element>) => void;
        setFocusIndex: (index: number) => void;
        setFocusBy: (by: string) => void;
        setDisableMouseFocus: (flag: boolean) => void;
        open: () => void;
        close: () => void;
        renderEmpty: () => React.ReactNode;
        renderDropDown: ({ getPopupContainer: getContextPopupContainer, getPrefixCls, }: import("../config-context").ConfigConsumerProps) => JSX.Element;
        render(): JSX.Element;
        context: any;
        setState<K extends "visible" | "filteredOptions" | "selected" | "focusIndex" | "menuPosition">(state: import("./interfaces").DropdownHOCState | ((prevState: Readonly<import("./interfaces").DropdownHOCState>, props: Readonly<DropdownHOCProps>) => import("./interfaces").DropdownHOCState | Pick<import("./interfaces").DropdownHOCState, K> | null) | Pick<import("./interfaces").DropdownHOCState, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<DropdownHOCProps> & Readonly<{
            children?: React.ReactNode;
        }>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<DropdownHOCProps>, nextState: Readonly<import("./interfaces").DropdownHOCState>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<DropdownHOCProps>, prevState: Readonly<import("./interfaces").DropdownHOCState>): any;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<DropdownHOCProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<DropdownHOCProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<DropdownHOCProps>, nextState: Readonly<import("./interfaces").DropdownHOCState>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<DropdownHOCProps>, nextState: Readonly<import("./interfaces").DropdownHOCState>, nextContext: any): void;
    };
    defaultProps: {
        multiple: boolean;
        options: never[];
        mouseEnterDelay: number;
        mouseLeaveDelay: number;
        placement: "topLeft" | "topCenter" | "topRight" | "bottomLeft" | "bottomCenter" | "bottomRight";
        empty: null;
        labelKey: string;
        valueKey: string;
        prefixKey: string;
        trigger: string;
    };
    contextType?: React.Context<any> | undefined;
};
export default _default;
