"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var rc_dropdown_1 = __importDefault(require("rc-dropdown"));
var classnames_1 = __importDefault(require("classnames"));
var SearchInput_1 = __importDefault(require("./SearchInput"));
var ClearanceOption_1 = __importDefault(require("./ClearanceOption"));
var DropdownHOC_1 = __importDefault(require("./DropdownHOC"));
var Check_1 = __importDefault(require("../icons/Check"));
var LazyLoadContainer_1 = __importDefault(require("./LazyLoadContainer"));
var AngleDown_1 = __importDefault(require("../icons/AngleDown"));
var Empty_1 = __importDefault(require("./Empty"));
// export interface DropdownState {
//   selectedLabel: string | string[];
//   selected: any | any[];
// }
/**
 * @example ./doc/dropdown.md
 * @visibleName Dropdown(下拉框)
 */
var Dropdown = /** @class */ (function (_super) {
    __extends(Dropdown, _super);
    function Dropdown() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.dropdownRef = react_1.default.createRef();
        _this.lazyLoadRef = react_1.default.createRef();
        _this.menuRef = react_1.default.createRef();
        _this.triggerRef = react_1.default.createRef();
        _this.adjustPopoverPosition = function () { return _this.props.adjustPopoverPosition(_this.triggerRef, _this.dropdownRef); };
        _this.handleVisibleChange = function (visible) {
            var onVisibleChange = _this.props.onVisibleChange;
            if (onVisibleChange)
                onVisibleChange(visible);
            if (_this.searchInputRef) {
                if (!visible) {
                    _this.searchInputRef.change('');
                }
                else {
                    setTimeout(function () {
                        _this.searchInputRef.input.current.focus();
                    });
                }
            }
            else if (visible && _this.dropdownRef) {
                setTimeout(function () {
                    _this.dropdownRef.current.focus();
                });
            }
        };
        _this.renderMenu = function () {
            var _a;
            // rc-dropdown already can process the function of menu, but we have check logic here.
            // So we need render the element to check and pass back to rc-dropdown.
            var _b = _this.props, menu = _b.menu, MenuItem = _b.MenuItem, prefixCls = _b.prefixCls, multiple = _b.multiple, options = _b.options, transitionName = _b.transitionName, labelKey = _b.labelKey, prefixKey = _b.prefixKey, filteredOptions = _b.filteredOptions, searchable = _b.searchable, searchPlaceholder = _b.searchPlaceholder, clearable = _b.clearable, visible = _b.visible, onSearch = _b.onSearch, onClear = _b.onClear, onSelect = _b.onSelect, selectedIndex = _b.selectedIndex, selected = _b.selected, onKeyDown = _b.onKeyDown, focusIndex = _b.focusIndex, setFocusIndex = _b.setFocusIndex, setFocusBy = _b.setFocusBy, disableMouseFocus = _b.disableMouseFocus, setDisableMouseFocus = _b.setDisableMouseFocus, onScrollBottom = _b.onScrollBottom, isLoading = _b.isLoading, placement = _b.placement, emptySearchDesc = _b.emptySearchDesc, menuPosition = _b.menuPosition, renderEmpty = _b.renderEmpty, offset = _b.offset, loadingComponent = _b.loadingComponent;
            var menuNode;
            // custom menu
            if (menu) {
                if (typeof menu === 'function') {
                    menuNode = menu();
                }
                else {
                    menuNode = menu;
                }
            }
            else if (options) {
                if (options.length === 0)
                    menuNode = renderEmpty();
                else {
                    var renderOptions = filteredOptions || options;
                    if (renderOptions !== null && renderOptions.length === 0) {
                        // 搜索且结果为空
                        menuNode = react_1.default.createElement(Empty_1.default, { type: "search", desc: emptySearchDesc });
                    }
                    else {
                        menuNode = (react_1.default.createElement("ul", { className: classnames_1.default(prefixCls + "-menu", {
                                'oa-cuk-dropdown-menu-scroll': !onScrollBottom,
                            }), ref: _this.menuRef, onMouseMove: function () { return setDisableMouseFocus(false); } }, renderOptions.map(function (opt, i) {
                            var _a;
                            var isSelected = selectedIndex(opt) > -1;
                            var cls = classnames_1.default(opt.className, (_a = {},
                                _a[prefixCls + "-menu-item"] = true,
                                _a[prefixCls + "-menu-item-select"] = isSelected,
                                _a[prefixCls + "-menu-item-focus"] = i === focusIndex,
                                _a));
                            var checkStatus = classnames_1.default(prefixCls + "-menu-item-check-icon", {
                                active: isSelected,
                            });
                            return (react_1.default.createElement("li", { 
                                // eslint-disable-next-line react/no-array-index-key
                                key: i, className: cls, onClick: function (e) { return onSelect(opt, e); }, onMouseEnter: function () {
                                    if (!disableMouseFocus) {
                                        setFocusBy('mouse');
                                        setFocusIndex(i);
                                    }
                                } },
                                multiple && react_1.default.createElement(Check_1.default, { className: checkStatus }),
                                MenuItem ? (react_1.default.createElement(MenuItem, __assign({}, _this.props, { item: opt, selectedItem: selected }))) : (react_1.default.createElement(react_1.default.Fragment, null,
                                    opt[prefixKey] && (react_1.default.createElement("span", { className: 'oa-cuk-menu-icon' }, opt[prefixKey])),
                                    opt[labelKey]))));
                        })));
                    }
                }
            }
            var menuCls = classnames_1.default((_a = {
                    'oa-cuk-dropdown-menu-container': true
                },
                _a[transitionName || ''] = !visible,
                _a["oa-cuk-dropdown-menu-" + menuPosition] = !placement || placement.indexOf('top') === -1,
                _a["oa-cuk-dropdown-placement-" + placement] = placement && placement.indexOf('top') > -1,
                _a));
            return (
            // eslint-disable-next-line jsx-a11y/no-noninteractive-tabindex
            react_1.default.createElement("div", { className: menuCls, tabIndex: 0, onKeyDown: onKeyDown, ref: _this.dropdownRef },
                searchable && (react_1.default.createElement("div", { onClick: function (e) { return e.stopPropagation(); } },
                    react_1.default.createElement(SearchInput_1.default, { ref: function (ref) { return (_this.searchInputRef = ref); }, placeholder: searchPlaceholder, onSearch: onSearch }))),
                clearable && react_1.default.createElement(ClearanceOption_1.default, { onClear: onClear }),
                onScrollBottom ? (react_1.default.createElement(LazyLoadContainer_1.default, { offset: offset, loadingComponent: loadingComponent, isLoading: isLoading, className: "oa-cuk-dropdown-menu-scroll", ref: _this.lazyLoadRef, onScrollBottom: onScrollBottom }, menuNode)) : (menuNode)));
        };
        _this.renderTrigger = function () {
            var _a = _this.props, selected = _a.selected, disabled = _a.disabled, labelKey = _a.labelKey, className = _a.className, prefixCls = _a.prefixCls, triggerText = _a.triggerText, triggerPrefix = _a.triggerPrefix, triggerSuffix = _a.triggerSuffix, triggerBorderless = _a.triggerBorderless, isTriggerTextAppendable = _a.isTriggerTextAppendable, children = _a.children;
            if (children)
                return children;
            var classes = classnames_1.default(className, prefixCls + "-trigger", disabled, {
                borderless: triggerBorderless,
            });
            var seletedText = '';
            if (selected && selected.length) {
                seletedText = selected.map(function (item) { return item[labelKey]; }).join(',');
            }
            var text = isTriggerTextAppendable ? triggerText + seletedText : seletedText || triggerText;
            return (react_1.default.createElement("div", { ref: _this.triggerRef, className: classes },
                triggerPrefix && (react_1.default.createElement("span", { className: prefixCls + "-trigger-prefix-icon" }, triggerPrefix)),
                react_1.default.createElement("div", { className: prefixCls + "-trigger-text" }, text),
                react_1.default.createElement("span", { className: prefixCls + "-trigger-suffix-icon" }, triggerSuffix || react_1.default.createElement(AngleDown_1.default, null))));
        };
        return _this;
    }
    Dropdown.prototype.componentDidMount = function () {
        if (this.props.placement && this.props.placement.indexOf('top') === -1)
            window.addEventListener('resize', this.adjustPopoverPosition());
    };
    Dropdown.prototype.componentWillUnmount = function () {
        if (this.props.placement && this.props.placement.indexOf('top') === -1)
            window.removeEventListener('resize', this.adjustPopoverPosition());
    };
    Dropdown.prototype.render = function () {
        var _a = this.props, triggerActions = _a.triggerActions, other = __rest(_a, ["triggerActions"]);
        return (react_1.default.createElement(rc_dropdown_1.default, __assign({}, other, { trigger: triggerActions, overlay: this.renderMenu(), onVisibleChange: this.handleVisibleChange, closeOnSelect: false }), this.renderTrigger()));
    };
    Dropdown.defaultProps = {
        triggerText: '',
    };
    return Dropdown;
}(react_1.default.Component));
exports.default = DropdownHOC_1.default(Dropdown);
//# sourceMappingURL=Dropdown.js.map