"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var lodash_isequal_1 = __importDefault(require("lodash.isequal"));
var lodash_throttle_1 = __importDefault(require("lodash.throttle"));
var config_context_1 = require("../config-context");
var Empty_1 = __importDefault(require("./Empty"));
var DropdownPos = {
    top: 'top',
    bottom: 'bottom',
    left: 'left',
    right: 'right',
};
/**
 *
 * @example ./doc/dropdown.md
 * @visibleName Dropdown(下拉框)
 */
function DropdownHOC(Dropdown) {
    var _a;
    return _a = /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.state = {
                    // options: this.props.options!,
                    selected: [],
                    visible: false,
                    focusIndex: -1,
                    filteredOptions: null,
                    menuPosition: DropdownPos.bottom,
                };
                _this.isControlled = _this.props.visible !== undefined;
                _this.disableMouseFocus = false;
                _this.focusBy = 'mouse';
                _this.adjustPopoverPosition = function (trigger, menu) {
                    return lodash_throttle_1.default(function () {
                        var menuPosition = _this.state.menuPosition;
                        if (!trigger || !trigger.current || !menu || !menu.current)
                            return;
                        var menuBox = menu.current.getBoundingClientRect();
                        var triggerBox = trigger.current.getBoundingClientRect();
                        var innerHeight = window.innerHeight;
                        var nextPosition = DropdownPos.bottom;
                        if (triggerBox.top + triggerBox.height + menuBox.height > innerHeight) {
                            nextPosition = DropdownPos.top;
                        }
                        if (nextPosition !== menuPosition) {
                            _this.setState({ menuPosition: nextPosition });
                        }
                    }, 50);
                };
                _this.handleVisibleChange = function (visible) {
                    var onVisibleChange = _this.props.onVisibleChange;
                    if (onVisibleChange) {
                        onVisibleChange(visible);
                    }
                    if (!_this.isControlled) {
                        _this.setState({
                            visible: visible,
                        });
                    }
                };
                _this.isVisible = function () {
                    return _this.isControlled ? _this.props.visible : _this.state.visible;
                };
                _this.getTransitionName = function () {
                    var _a = _this.props, _b = _a.placement, placement = _b === void 0 ? '' : _b, transitionName = _a.transitionName;
                    if (transitionName !== undefined) {
                        return transitionName;
                    }
                    if (placement.indexOf('top') >= 0) {
                        return 'slide-down';
                    }
                    return 'slide-up';
                };
                _this.selectedIndex = function (option) {
                    return _this.state.selected.findIndex(function (s) { return lodash_isequal_1.default(s, option); });
                };
                _this.handleSelect = function (option, e) {
                    var _a = _this.props, onSelect = _a.onSelect, options = _a.options, multiple = _a.multiple, labelKey = _a.labelKey;
                    var selected = [];
                    if (multiple) {
                        e.stopPropagation();
                        var i = _this.selectedIndex(option);
                        selected = _this.state.selected;
                        if (i > -1) {
                            selected.splice(i, 1);
                        }
                        else {
                            selected.push(option);
                        }
                    }
                    else if (options) {
                        selected = options.filter(function (opt) { return opt[labelKey] === option[labelKey]; });
                    }
                    _this.setState({ selected: selected }, function () {
                        if (onSelect)
                            onSelect(option, _this.state.selected, e);
                        if (!multiple)
                            _this.close();
                    });
                };
                _this.getSelected = function () {
                    return _this.state.selected;
                };
                _this.defaultSearch = function (val, options) {
                    if (val === '')
                        return options;
                    return options.filter(function (opt) {
                        return opt[_this.props.labelKey] !== undefined &&
                            opt[_this.props.labelKey].toLowerCase().indexOf(val) > -1;
                    });
                };
                _this.handleSearch = function (val) {
                    var _a = _this.props, customSearch = _a.onSearch, options = _a.options;
                    var onSearch = customSearch || _this.defaultSearch;
                    var result = onSearch(val, options);
                    _this.setState({
                        filteredOptions: val === '' ? null : result,
                        focusIndex: result.length ? 0 : -1,
                    });
                };
                _this.handleClear = function () {
                    var _a = _this.props, multiple = _a.multiple, onClear = _a.onClear;
                    if (onClear) {
                        onClear(_this.state.selected);
                    }
                    if (multiple) {
                        _this.setState({
                            selected: [],
                            focusIndex: -1,
                        });
                    }
                };
                _this.handleKeyDown = function (e) {
                    if (e.key === 'Escape') {
                        _this.close();
                        // this.dropdown.focus();
                    }
                    else if (e.key === 'ArrowDown') {
                        e.preventDefault();
                        if (!_this.isVisible()) {
                            _this.open();
                        }
                        else {
                            _this.onDownArrow();
                        }
                    }
                    else if (e.key === 'ArrowUp') {
                        if (_this.isVisible()) {
                            e.preventDefault();
                            _this.onUpArrow();
                        }
                    }
                    else if (e.key === 'Enter') {
                        _this.onReturn(e);
                        if (!_this.props.multiple)
                            _this.close();
                    }
                };
                _this.onDownArrow = function () {
                    var _a = _this.state, focusIndex = _a.focusIndex, filteredOptions = _a.filteredOptions;
                    _this.disableMouseFocus = true;
                    _this.focusBy = 'arrow';
                    if (focusIndex === -1) {
                        _this.setState({ focusIndex: 0 });
                    }
                    else {
                        var renderItems = filteredOptions || _this.props.options;
                        var nextFocusIndex = focusIndex + 1 === renderItems.length ? 0 : focusIndex + 1;
                        _this.setState({ focusIndex: nextFocusIndex });
                    }
                };
                _this.onUpArrow = function () {
                    var _a = _this.state, focusIndex = _a.focusIndex, filteredOptions = _a.filteredOptions;
                    var renderItems = filteredOptions || _this.props.options;
                    var nextFocusIndex = focusIndex - 1 < 0 ? renderItems.length - 1 : focusIndex - 1;
                    _this.disableMouseFocus = true;
                    _this.focusBy = 'arrow';
                    _this.setState({ focusIndex: nextFocusIndex });
                };
                _this.onReturn = function (e) {
                    var _a = _this.state, focusIndex = _a.focusIndex, filteredOptions = _a.filteredOptions;
                    var renderItems = filteredOptions || _this.props.options;
                    if (_this.props.multiple) {
                        e.preventDefault();
                    }
                    if (focusIndex > -1) {
                        _this.handleSelect(renderItems[focusIndex], e);
                    }
                };
                _this.setFocusIndex = function (index) {
                    _this.setState({
                        focusIndex: index,
                    });
                };
                _this.setFocusBy = function (by) {
                    _this.focusBy = by;
                };
                _this.setDisableMouseFocus = function (flag) {
                    _this.disableMouseFocus = flag;
                };
                _this.open = function () {
                    if (_this.isControlled && _this.props.onToggle) {
                        _this.props.onToggle(true);
                        return;
                    }
                    _this.setState({
                        visible: true,
                    });
                };
                _this.close = function () {
                    if (_this.isControlled && _this.props.onToggle) {
                        _this.props.onToggle(false);
                        return;
                    }
                    _this.setState({
                        visible: false,
                    });
                };
                _this.renderEmpty = function () {
                    var _a = _this.props, options = _a.options, empty = _a.empty, emptyDesc = _a.emptyDesc;
                    if (options.length) {
                        return null;
                    }
                    return empty || react_1.default.createElement(Empty_1.default, { type: "menu", desc: emptyDesc });
                };
                _this.renderDropDown = function (_a) {
                    var getContextPopupContainer = _a.getPopupContainer, getPrefixCls = _a.getPrefixCls;
                    var _b = _this.props, customizePrefixCls = _b.prefixCls, trigger = _b.trigger, disabled = _b.disabled, getPopupContainer = _b.getPopupContainer, other = __rest(_b, ["prefixCls", "trigger", "disabled", "getPopupContainer"]);
                    var prefixCls = getPrefixCls('dropdown', customizePrefixCls);
                    var triggerActions = disabled ? [] : [trigger];
                    return (react_1.default.createElement(Dropdown
                    // TODO: remove any
                    , __assign({}, other, { ref: function (ref) { return (_this.hocRef = ref); }, renderEmpty: _this.renderEmpty, prefixCls: prefixCls, triggerActions: triggerActions, getPopupContainer: getPopupContainer || getContextPopupContainer, selected: _this.getSelected(), transitionName: _this.getTransitionName(), onSelect: _this.handleSelect, onSearch: _this.handleSearch, filteredOptions: _this.state.filteredOptions, selectedIndex: _this.selectedIndex, onClear: _this.handleClear, onVisibleChange: _this.handleVisibleChange, visible: _this.isVisible(), onKeyDown: _this.handleKeyDown, focusIndex: _this.state.focusIndex, setFocusIndex: _this.setFocusIndex, focusBy: _this.focusBy, setFocusBy: _this.setFocusBy, disableMouseFocus: _this.disableMouseFocus, setDisableMouseFocus: _this.setDisableMouseFocus, menuPosition: _this.state.menuPosition, adjustPopoverPosition: _this.adjustPopoverPosition })));
                };
                return _this;
            }
            class_1.prototype.componentDidUpdate = function () {
                var focusIndex = this.state.focusIndex;
                if (focusIndex > -1 && this.hocRef && this.hocRef.menuRef && this.focusBy === 'arrow') {
                    var menuContainer = void 0;
                    if (this.props.onScrollBottom && this.hocRef.lazyLoadRef) {
                        menuContainer = this.hocRef.lazyLoadRef.current.container.current;
                    }
                    else {
                        menuContainer = this.hocRef.menuRef.current;
                    }
                    var focusItem = menuContainer.querySelectorAll('li')[focusIndex];
                    var menuRect = menuContainer.getBoundingClientRect();
                    if (focusItem === undefined)
                        return; // 搜索结果为空时
                    var focusRect = focusItem.getBoundingClientRect();
                    var focusBottomOffset = focusRect.top + focusRect.height - menuRect.top;
                    if (focusBottomOffset > menuRect.height) {
                        // hide bottom, scroll down
                        menuContainer.scrollTop += focusBottomOffset - menuRect.height;
                    }
                    else if (focusBottomOffset < focusRect.height) {
                        // hide top, scroll up
                        menuContainer.scrollTop -= focusRect.height - focusBottomOffset;
                    }
                }
            };
            class_1.prototype.render = function () {
                return react_1.default.createElement(config_context_1.ConfigConsumer, null, this.renderDropDown);
            };
            return class_1;
        }(react_1.default.Component)),
        _a.defaultProps = {
            multiple: false,
            options: [],
            mouseEnterDelay: 0.15,
            mouseLeaveDelay: 0.1,
            placement: 'bottomLeft',
            empty: null,
            labelKey: 'label',
            valueKey: 'value',
            prefixKey: 'prefix',
            trigger: 'hover',
        },
        _a;
}
exports.default = DropdownHOC;
//# sourceMappingURL=DropdownHOC.js.map