"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var input_1 = __importDefault(require("../input"));
var Search_1 = __importDefault(require("../icons/Search"));
var SearchInput = /** @class */ (function (_super) {
    __extends(SearchInput, _super);
    function SearchInput(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            value: '',
        };
        _this.handleChange = _this.handleChange.bind(_this);
        _this.handlePressEnter = _this.handlePressEnter.bind(_this);
        _this.change = _this.change.bind(_this);
        return _this;
    }
    SearchInput.prototype.change = function (value) {
        this.setState({ value: value });
        this.props.onSearch(value);
    };
    SearchInput.prototype.handleChange = function (value) {
        this.change(value);
    };
    SearchInput.prototype.handlePressEnter = function () {
        if (this.props.clearOnPressEnter) {
            this.change('');
        }
    };
    SearchInput.prototype.render = function () {
        var _this = this;
        var placeholder = this.props.placeholder;
        var value = this.state.value;
        return (react_1.default.createElement("div", { className: "oa-cuk-search" },
            react_1.default.createElement(input_1.default, { className: "oa-cuk-search-input", type: "text", focus: true, ref: function (ref) { return (_this.input = ref && ref.input); }, value: value, placeholder: placeholder, onPressEnter: this.handlePressEnter, onChange: this.handleChange, suffix: react_1.default.createElement(Search_1.default, null) })));
    };
    SearchInput.defaultProps = {
        placeholder: '搜索',
        onSearch: function () { },
        clearOnPressEnter: false,
    };
    return SearchInput;
}(react_1.default.Component));
exports.default = SearchInput;
//# sourceMappingURL=SearchInput.js.map