"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var helper_1 = require("../_base/helper");
function Group(props) {
    var children = props.children, className = props.className, style = props.style, compact = props.compact, size = props.size, dividerLess = props.dividerLess;
    var groupClassName = [
        'input-group',
        { 'input-group-compact': compact },
        { 'input-group-divider-less': dividerLess },
    ];
    var renderChild = function () {
        return react_1.default.Children.map(children, function (child) {
            if (!react_1.default.isValidElement(child)) {
                return child;
            }
            return react_1.default.cloneElement(child, { size: size });
        });
    };
    return (react_1.default.createElement("span", { className: classnames_1.default(helper_1.getClassName(groupClassName), className), style: style }, renderChild()));
}
exports.default = Group;
//# sourceMappingURL=Group.js.map