import React from 'react';
import { BaseProps } from '../_base/interface';
import './style/inputNumber.scss';
export interface IProps extends BaseProps {
    size?: 'small' | 'default' | 'large' | 'xLarge';
    value?: number;
    defaultValue?: number;
    disabled?: boolean;
    focus?: boolean;
    min?: number;
    max?: number;
    step?: number;
    placeholder?: string;
    onChange?: (value?: number | '') => void;
    onPressEnter?: (value?: string) => void;
    onFocus?: (e?: React.FocusEvent) => void;
    onBlur?: (e?: React.FocusEvent) => void;
}
interface IState {
    value: number | undefined;
    displayValue: string | undefined;
}
export default class InputNumber extends React.Component<IProps> {
    state: {
        value: number;
        displayValue: string;
    };
    static defaultProps: {
        min: number;
        max: number;
        step: number;
    };
    static getDerivedStateFromProps(props: IProps, state: IState): {
        value: number | "";
    } | {
        value: number | undefined;
    };
    componentDidMount(): void;
    componentDidUpdate(prevProps: IProps): void;
    handleChange: (value?: string | number | undefined) => void;
    calculateAndSetValue: (isAdd: boolean) => void;
    handleAdd: () => void;
    handleDesc: () => void;
    checkValue: (value?: number | undefined) => {
        value: number;
        displayValue: string;
    };
    handleBlur: (e?: React.FocusEvent<Element> | undefined) => void;
    correctValue: () => void;
    renderSuffix: () => JSX.Element;
    render(): JSX.Element;
}
export {};
