"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var object_omit_1 = __importDefault(require("object.omit"));
var helper_1 = require("../_base/helper");
var Input_1 = __importDefault(require("./Input"));
require("./style/inputNumber.scss");
// eslint-disable-next-line no-restricted-properties
var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || Math.pow(2, 53) - 1;
function parseValue(value, max, min) {
    if (max === void 0) { max = MAX_SAFE_INTEGER; }
    if (min === void 0) { min = -MAX_SAFE_INTEGER; }
    var nextValue = value;
    if (nextValue == null || nextValue === '') {
        return '';
    }
    if (typeof nextValue === 'string') {
        nextValue = parseFloat(nextValue);
    }
    if (isNaN(nextValue)) {
        nextValue = 0;
    }
    return Math.max(Math.min(nextValue, max), min);
}
function calculate(isAdd, num1, num2) {
    if (num1 === void 0) { num1 = 0; }
    if (num2 === void 0) { num2 = 0; }
    var num1Str = "" + num1;
    var num2Str = "" + num2;
    var num1Decimal = num1Str.length - (Math.max(num1Str.indexOf('.'), 0) + 1);
    var num2Decimal = num2Str.length - (Math.max(num2Str.indexOf('.'), 0) + 1);
    var decimalPlace = 0;
    if (num1Decimal !== num1Str.length) {
        decimalPlace = num1Decimal;
    }
    if (num2Decimal !== num2Str.length && num2Decimal > decimalPlace) {
        decimalPlace = num2Decimal;
    }
    // eslint-disable-next-line no-restricted-properties
    var scale = Math.pow(10, decimalPlace);
    var result = 0;
    if (isAdd) {
        result = scale * num1 + scale * num2;
    }
    else {
        result = scale * num1 - scale * num2;
    }
    result = Math.round(result) / scale;
    return result;
}
function parseStep(step) {
    if (step === void 0) { step = 1; }
    return isNaN(parseFloat("" + step)) ? 1 : parseFloat("" + step);
}
function padEnd(originStr, padLength, fillStr) {
    return "" + originStr + new Array(padLength).fill(fillStr).join('');
}
var InputNumber = /** @class */ (function (_super) {
    __extends(InputNumber, _super);
    function InputNumber() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: 0,
            displayValue: '',
        };
        _this.handleChange = function (value) {
            var _a = _this.props, onChange = _a.onChange, max = _a.max, min = _a.min;
            var nextValue = parseValue(value, max, min);
            var displayValue = "" + nextValue;
            if (typeof value === 'string' &&
                displayValue !== value &&
                /^((-\d*)|(\d+))?\.?(\d*)$/.test(value) &&
                nextValue !== max &&
                nextValue !== min) {
                displayValue = value;
            }
            _this.setState({
                value: nextValue,
                displayValue: displayValue,
            });
            if (onChange)
                onChange(nextValue);
        };
        _this.calculateAndSetValue = function (isAdd) {
            var _a = _this.props.step, step = _a === void 0 ? 1 : _a;
            var nextValue = parseValue(_this.state.value) || 0;
            if (isAdd) {
                nextValue = calculate(isAdd, nextValue, parseStep(step));
            }
            else {
                nextValue = calculate(isAdd, nextValue, parseStep(step));
            }
            var next = _this.checkValue(nextValue);
            _this.handleChange(next.displayValue);
        };
        _this.handleAdd = function () {
            var _a = _this.props.max, max = _a === void 0 ? MAX_SAFE_INTEGER : _a;
            if (_this.state.value < max) {
                _this.calculateAndSetValue(true);
            }
        };
        _this.handleDesc = function () {
            var _a = _this.props.min, min = _a === void 0 ? -MAX_SAFE_INTEGER : _a;
            if (_this.state.value > min) {
                _this.calculateAndSetValue(false);
            }
        };
        _this.checkValue = function (value) {
            var step = _this.props.step;
            var displayValue = "" + value;
            if (value == null) {
                value = _this.state.value;
                displayValue = _this.state.displayValue;
            }
            var reg = /^-?\d+.(\d+)$/;
            var match = reg.exec("" + parseStep(step));
            // 下面代码主要是为了根据step来补齐或者截断小数位数
            if (match && typeof value === 'number') {
                var decimalLength = match[1].length;
                var valueMatch = reg.exec(displayValue);
                var diff = 0;
                do {
                    if (!valueMatch) {
                        displayValue = padEnd(displayValue + ".", decimalLength, '0');
                        diff = 0;
                    }
                    else {
                        diff = valueMatch[1].length - decimalLength;
                        if (diff > 0) {
                            // eslint-disable-next-line no-restricted-properties
                            var scale = Math.pow(10, decimalLength);
                            displayValue = "" + Math.round(value * scale) / scale;
                            valueMatch = reg.exec(displayValue);
                            diff = valueMatch ? valueMatch[1].length - decimalLength : decimalLength;
                        }
                        else if (diff < 0) {
                            displayValue = padEnd(displayValue, -diff, '0');
                        }
                    }
                } while (diff > 0);
                value = parseFloat(displayValue);
            }
            return { value: value, displayValue: displayValue };
        };
        _this.handleBlur = function (e) {
            var onBlur = _this.props.onBlur;
            _this.correctValue();
            if (onBlur)
                onBlur(e);
        };
        _this.correctValue = function () {
            var onChange = _this.props.onChange;
            var displayValue = _this.state.displayValue;
            var next = _this.checkValue();
            if (next.displayValue !== displayValue) {
                if (onChange)
                    onChange(next.value);
                _this.setState(next);
            }
        };
        _this.renderSuffix = function () {
            var _a = _this.state.value, value = _a === void 0 ? 0 : _a;
            var _b = _this.props, _c = _b.max, max = _c === void 0 ? Infinity : _c, _d = _b.min, min = _d === void 0 ? -Infinity : _d;
            var addClassName = helper_1.getClassName([
                'input-number-btn',
                'input-number-btn-add',
                { disabled: max <= value },
            ]);
            var descClassName = helper_1.getClassName([
                'input-number-btn',
                'input-number-btn-desc',
                { disabled: min >= value },
            ]);
            return (react_1.default.createElement("span", { className: helper_1.getClassName('input-number-btn-wrap') },
                react_1.default.createElement("span", { onClick: _this.handleAdd, className: addClassName }, "+"),
                react_1.default.createElement("span", { onClick: _this.handleDesc, className: descClassName }, "-")));
        };
        return _this;
    }
    InputNumber.getDerivedStateFromProps = function (props, state) {
        if (props.value !== undefined) {
            return { value: parseValue(props.value, props.max, props.min) };
        }
        return { value: state.value };
    };
    InputNumber.prototype.componentDidMount = function () {
        var _a = this.props, value = _a.value, defaultValue = _a.defaultValue, max = _a.max, min = _a.min, onChange = _a.onChange;
        var currentValue = NaN;
        if (value != null) {
            currentValue = value;
        }
        else if (defaultValue != null) {
            currentValue = defaultValue;
        }
        if (currentValue != null && !isNaN(currentValue)) {
            var parsedValue = parseValue(currentValue, max, min);
            var result = this.checkValue(parsedValue);
            this.setState(result);
            if (result.value !== currentValue && onChange) {
                onChange(result.value);
            }
        }
    };
    InputNumber.prototype.componentDidUpdate = function (prevProps) {
        var _a = this.props, max = _a.max, min = _a.min, value = _a.value;
        if (max !== prevProps.max || min !== prevProps.min) {
            this.handleChange(value);
        }
    };
    InputNumber.prototype.render = function () {
        var resetProps = object_omit_1.default(this.props, ['min', 'max', 'step']);
        return (react_1.default.createElement(Input_1.default, __assign({}, resetProps, { value: this.state.displayValue, onChange: this.handleChange, onBlur: this.handleBlur, showAffixOnlyMouseEnter: true, suffix: this.renderSuffix() })));
    };
    InputNumber.defaultProps = {
        min: -MAX_SAFE_INTEGER,
        max: MAX_SAFE_INTEGER,
        step: 1,
    };
    return InputNumber;
}(react_1.default.Component));
exports.default = InputNumber;
//# sourceMappingURL=InputNumber.js.map