import React from 'react';
import MenuItem from './MenuItem';
import SubMenu from './SubMenu';
import Divider from './Divider';
import MenuItemGroup from './MenuItemGroup';
export declare const VERTICAL_MODE = "vertical";
export declare const INLINE_MODE = "inline";
export declare const INLINE_COLLAPSED_MODE = "inline-collapsed";
export declare type menuMode = 'vertical' | 'inline' | 'inline-collapsed';
export declare const DARK_THEME = "dark";
export declare const LIGHT_THEME = "light";
export declare type Themes = 'dark' | 'light';
export interface MenuProps {
    children?: React.ReactElement[];
    activeKey?: string;
    defaultActiveKey?: string;
    onSelect: (key?: string) => void;
    openKeys?: string[];
    defaultOpenKeys?: [];
    onOpenChange?: (nextOpenKeys: string[], key: string) => {};
    mode?: menuMode;
    theme?: Themes;
    className?: string;
    style?: object;
    getPopupContainer?: () => {};
    open?: boolean;
}
declare type MenuState = {
    openKeys?: string[];
    activeKey?: string;
};
/**
 * @example ./doc/menu.md
 */
declare class Menu extends React.Component<MenuProps, MenuState> {
    static defaultProps: {
        onSelect: (key?: string | undefined) => null;
        defaultOpenKeys: never[];
        theme: string;
        mode: string;
        className: string;
        style: {};
    };
    isRootMenu: boolean;
    static MenuItem: typeof MenuItem;
    static MenuItemGroup: typeof MenuItemGroup;
    static SubMenu: typeof SubMenu;
    static Divider: typeof Divider;
    constructor(props: MenuProps);
    static getDerivedStateFromProps(nextProps: MenuProps, prevState: MenuState): {
        openKeys: string[] | undefined;
        activeKey: string | undefined;
    };
    renderItem: (child: React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>, index: number, subIndex: number, outer?: boolean) => React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>;
    onSubMenuSelect: (key: string) => void;
    render(): JSX.Element;
}
export default Menu;
