"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var classnames_1 = __importDefault(require("classnames"));
var rc_trigger_1 = __importDefault(require("rc-trigger"));
var Menu_1 = require("./Menu");
var autoAdjustOverflow = {
    adjustX: 1,
    adjustY: 1,
};
exports.placements = {
    topLeft: {
        points: ['bl', 'tl'],
        overflow: autoAdjustOverflow,
        offset: [0, -7],
    },
    bottomLeft: {
        points: ['tl', 'bl'],
        overflow: autoAdjustOverflow,
        offset: [0, 7],
    },
    leftTop: {
        points: ['tr', 'tl'],
        overflow: autoAdjustOverflow,
        offset: [-2, 0],
    },
    rightTop: {
        points: ['tl', 'tr'],
        overflow: autoAdjustOverflow,
        offset: [2, 0],
    },
};
var SubMenu = /** @class */ (function (_super) {
    __extends(SubMenu, _super);
    function SubMenu() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.renderInnerMenuItem = function (item, i) {
            var _a = _this.props, renderItem = _a.renderItem, index = _a.index;
            return renderItem(item, i, index);
        };
        _this.renderInnerMenu = function () {
            var _a;
            var _b = _this.props, children = _b.children, theme = _b.theme, mode = _b.mode;
            var menuClasses = classnames_1.default((_a = {
                    'oa-cuk-sub-menu-list': true,
                    'oa-cuk-sub-menu-list-inline': mode === Menu_1.INLINE_MODE,
                    'oa-cuk-sub-menu-list-inline-collapsed': mode === Menu_1.INLINE_COLLAPSED_MODE
                },
                _a["oa-cuk-sub-menu-list-theme-" + theme] = true,
                _a));
            return (react_1.default.createElement("ul", { className: menuClasses, key: 'menu' }, react_1.default.Children.map(children, _this.renderInnerMenuItem)));
        };
        _this.isShowIconOnly = function () {
            var _a = _this.props, outer = _a.outer, mode = _a.mode;
            return mode === Menu_1.INLINE_COLLAPSED_MODE && outer;
        };
        _this.renderVerticalMenu = function () {
            var _a = _this.props, title = _a.title, onTitleClick = _a.onTitleClick, onSelect = _a.onSelect, icon = _a.icon, outer = _a.outer;
            var classes = classnames_1.default({
                'oa-cuk-sub-menu-title': true,
                'oa-cuk-sub-menu-title-outer': outer,
            });
            var showIconOnly = _this.isShowIconOnly();
            return [
                react_1.default.createElement("div", { className: classes, onClick: function () {
                        onTitleClick();
                        onSelect();
                    }, key: 'title' },
                    icon && react_1.default.createElement("span", { className: 'oa-cuk-menu-icon' }, icon),
                    !showIconOnly && title),
                _this.renderInnerMenu(),
            ];
        };
        _this.renderInlineMenu = function () {
            var _a = _this.props, title = _a.title, onTitleClick = _a.onTitleClick, onSelect = _a.onSelect, open = _a.open, active = _a.active, icon = _a.icon, outer = _a.outer;
            var classes = classnames_1.default({
                'oa-cuk-sub-menu-title': true,
                'oa-cuk-sub-menu-title-active': active || open,
                'oa-cuk-sub-menu-title-outer': outer,
            });
            var showIconOnly = _this.isShowIconOnly();
            // prettier-ignore
            // @ts-ignore
            var getPopupContainer = _this.props.parentMenu.isRootMenu ? _this.props.parentMenu.props.getPopupContainer
                : function (triggerNode) { return triggerNode.parentNode; };
            return (react_1.default.createElement(rc_trigger_1.default, { builtinPlacements: exports.placements, popup: _this.renderInnerMenu(), popupPlacement: "rightTop", action: ['hover'], onPopupVisibleChange: onSelect, popupVisible: open, getPopupContainer: getPopupContainer },
                react_1.default.createElement("div", { className: classes, onClick: function () {
                        onTitleClick();
                    } },
                    icon && react_1.default.createElement("span", { className: 'oa-cuk-menu-icon' }, icon),
                    !showIconOnly && title)));
        };
        return _this;
    }
    SubMenu.prototype.render = function () {
        var _a;
        var _b = this.props, className = _b.className, open = _b.open, mode = _b.mode, style = _b.style, icon = _b.icon;
        var classNames = classnames_1.default((_a = {
                'oa-cuk-sub-menu': true,
                'oa-cuk-sub-menu-active': open,
                'oa-cuk-sub-menu-inline-collapsed': mode === Menu_1.INLINE_COLLAPSED_MODE,
                'oa-cuk-sub-menu-with-icon': icon
            },
            _a[className] = className,
            _a));
        return (react_1.default.createElement("li", { className: classNames, style: style },
            mode === Menu_1.VERTICAL_MODE && this.renderVerticalMenu(),
            mode === Menu_1.INLINE_MODE && this.renderInlineMenu(),
            mode === Menu_1.INLINE_COLLAPSED_MODE && this.renderInlineMenu()));
    };
    SubMenu.isSubMenu = true;
    SubMenu.defaultProps = {
        onTitleClick: function () { },
        onSelect: function () { },
        className: '',
        style: {},
    };
    return SubMenu;
}(react_1.default.Component));
exports.default = SubMenu;
//# sourceMappingURL=SubMenu.js.map