"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
var helper_1 = require("../_base/helper");
var modal_1 = __importDefault(require("./modal"));
require("./style/index.scss");
exports.confirms = [];
function ConfirmModal(_a) {
    var content = _a.content, title = _a.title, description = _a.description, others = __rest(_a, ["content", "title", "description"]);
    var props = __assign(__assign({}, others), { title: title && react_1.default.createElement("h4", { className: helper_1.getClassName('confirm-modal-title') }, title) });
    return (react_1.default.createElement(modal_1.default, __assign({}, props),
        react_1.default.createElement(react_1.default.Fragment, null, content || description)));
}
function confirm(_a, autoClose) {
    var onClose = _a.onClose, onOk = _a.onOk, others = __rest(_a, ["onClose", "onOk"]);
    var div = document.createElement('div');
    document.body.appendChild(div);
    var destroyed = false;
    function destroy() {
        if (onClose)
            onClose();
        react_dom_1.default.unmountComponentAtNode(div);
        document.body.removeChild(div);
        destroyed = true;
        // eslint-disable-next-line no-use-before-define
        var index = exports.confirms.findIndex(function (item) { return item === close; });
        if (index > -1) {
            exports.confirms.splice(index, 1);
        }
    }
    function close() {
        // eslint-disable-next-line no-use-before-define
        update({ visible: false });
    }
    function handleOk() {
        if (onOk)
            onOk();
        if (autoClose) {
            close();
        }
    }
    var props = __assign(__assign({ maskVisible: false, escCloseable: false, closeable: false, centered: true }, others), { visible: true, onClose: destroy, onOk: handleOk });
    var render = function (config) {
        react_dom_1.default.render(react_1.default.createElement(ConfirmModal, __assign({}, config)), div);
    };
    function update(config) {
        if (config.whenOkDestroy !== autoClose) {
            autoClose = config.whenOkDestroy;
        }
        if (!destroyed) {
            props = __assign(__assign({}, props), config);
            render(__assign({}, props));
        }
    }
    render(props);
    exports.confirms.push(close);
    return {
        update: update,
        destroy: close,
    };
}
exports.default = confirm;
//# sourceMappingURL=confirm.js.map