"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var PropTypes = __importStar(require("prop-types"));
var classnames_1 = __importDefault(require("classnames"));
var shallowequal_1 = __importDefault(require("shallowequal"));
var radio_1 = __importDefault(require("./radio"));
var config_context_1 = require("../config-context");
var sizeContext_1 = __importDefault(require("../config-context/sizeContext"));
function getCheckedValue(children) {
    var value = null;
    var matched = false;
    React.Children.forEach(children, function (radio) {
        if (radio && radio.props && radio.props.checked) {
            value = radio.props.value;
            matched = true;
        }
    });
    return matched ? { value: value } : undefined;
}
var RadioGroup = /** @class */ (function (_super) {
    __extends(RadioGroup, _super);
    function RadioGroup(props) {
        var _this = _super.call(this, props) || this;
        _this.onRadioChange = function (ev) {
            var lastValue = _this.state.value;
            var value = ev.target.value;
            if (!('value' in _this.props)) {
                _this.setState({
                    value: value,
                });
            }
            var onChange = _this.props.onChange;
            if (onChange && value !== lastValue) {
                onChange(ev);
            }
        };
        _this.renderGroup = function (_a) {
            var getPrefixCls = _a.getPrefixCls;
            var props = _this.props;
            var customizePrefixCls = props.prefixCls, _b = props.className, className = _b === void 0 ? '' : _b, options = props.options, buttonStyle = props.buttonStyle, customizeSize = props.size;
            var prefixCls = getPrefixCls('radio', customizePrefixCls);
            var groupPrefixCls = prefixCls + "-group";
            var children = props.children;
            // 如果存在 options, 优先使用
            if (options && options.length > 0) {
                children = options.map(function (option) {
                    if (typeof option === 'string') {
                        // 此处类型自动推导为 string
                        return (React.createElement(radio_1.default, { key: option, prefixCls: prefixCls, disabled: _this.props.disabled, value: option, checked: _this.state.value === option }, option));
                    }
                    // 此处类型自动推导为 { label: string value: string }
                    return (React.createElement(radio_1.default, { key: "radio-group-value-options-" + option.value, prefixCls: prefixCls, disabled: option.disabled || _this.props.disabled, value: option.value, checked: _this.state.value === option.value }, option.label));
                });
            }
            return (React.createElement(sizeContext_1.default.Consumer, null, function (size) {
                var _a;
                var mergedSize = customizeSize || size;
                var classString = classnames_1.default(groupPrefixCls, groupPrefixCls + "-" + buttonStyle, (_a = {},
                    _a[groupPrefixCls + "-" + mergedSize] = mergedSize,
                    _a), className);
                return (React.createElement("div", { className: classString, style: props.style, onMouseEnter: props.onMouseEnter, onMouseLeave: props.onMouseLeave, id: props.id }, children));
            }));
        };
        var value;
        if ('value' in props) {
            value = props.value;
        }
        else if ('defaultValue' in props) {
            value = props.defaultValue;
        }
        else {
            var checkedValue = getCheckedValue(props.children);
            value = checkedValue && checkedValue.value;
        }
        _this.state = {
            value: value,
        };
        return _this;
    }
    RadioGroup.getDerivedStateFromProps = function (nextProps) {
        if ('value' in nextProps) {
            return {
                value: nextProps.value,
            };
        }
        var checkedValue = getCheckedValue(nextProps.children);
        if (checkedValue) {
            return {
                value: checkedValue.value,
            };
        }
        return null;
    };
    RadioGroup.prototype.getChildContext = function () {
        return {
            radioGroup: {
                onChange: this.onRadioChange,
                value: this.state.value,
                disabled: this.props.disabled,
                name: this.props.name,
            },
        };
    };
    RadioGroup.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        return !shallowequal_1.default(this.props, nextProps) || !shallowequal_1.default(this.state, nextState);
    };
    RadioGroup.prototype.render = function () {
        return React.createElement(config_context_1.ConfigConsumer, null, this.renderGroup);
    };
    RadioGroup.defaultProps = {
        buttonStyle: 'outline',
    };
    RadioGroup.childContextTypes = {
        radioGroup: PropTypes.any,
    };
    return RadioGroup;
}(React.Component));
exports.default = RadioGroup;
//# sourceMappingURL=group.js.map