import React from 'react';
import { TableProps, TableState, ColumnProps } from './interfaces';
import { ConfigConsumerProps } from '../config-context';
declare function noop(): void;
/**
 * @example ./doc/table.md
 */
export default class Table<T> extends React.Component<TableProps<T>, TableState<T>> {
    static defaultProps: {
        rowKey: string;
    };
    constructor(props: TableProps<T>);
    static getDerivedStateFromProps(nextProps: TableProps<any>, prevState: TableState<any>): TableState<any>;
    getDefaultPagination(props: TableProps<T>): {
        total: number;
    } | {
        current: number;
        pageSize: number;
        position?: "both" | "bottom" | "top" | undefined;
        total?: number | undefined;
        defaultCurrent?: number | undefined;
        disabled?: boolean | undefined;
        defaultPageSize?: number | undefined;
        onChange: ((page: number, pageSize?: number | undefined) => void) | typeof noop;
        hideOnSinglePage?: boolean | undefined;
        showSizeChanger?: boolean | undefined;
        pageSizeOptions?: string[] | undefined;
        onShowSizeChange: ((current: number, size: number) => void) | typeof noop;
        showQuickJumper?: boolean | {
            goButton?: React.ReactNode;
        } | undefined;
        showTitle?: boolean | undefined;
        showTotal?: ((total: number, range: [number, number]) => React.ReactNode) | undefined;
        size?: "big" | "default" | undefined;
        responsive?: boolean | undefined;
        simple?: boolean | undefined;
        style?: React.CSSProperties | undefined;
        locale?: Object | undefined;
        className?: string | undefined;
        prefixCls?: string | undefined;
        selectPrefixCls?: string | undefined;
        itemRender?: ((page: number, type: string, element: React.ReactNode) => React.ReactNode) | undefined;
        role?: string | undefined;
        showLessItems?: boolean | undefined;
    };
    hasPagination(props?: any): boolean;
    isSortColumn(column: ColumnProps<T>): boolean;
    getSortOrderColumns(columns?: ColumnProps<T>[]): any;
    getSortStateFromColumns(columns?: ColumnProps<T>[]): {
        sortColumn: any;
        sortOrder: any;
    };
    getDefaultSortOrder(columns?: ColumnProps<T>[]): {
        sortColumn: any;
        sortOrder: any;
    };
    toggleSortOrder(column: ColumnProps<T>): void;
    recursiveSort(data: T[], sorterFn: (a: any, b: any) => number): T[];
    getSorterFn(state: TableState<T>): ((a: T, b: T) => number) | undefined;
    handlePageChange: (current: number, ...otherArguments: any[]) => void;
    getMaxPage(total: number): number | undefined;
    getMaxCurrent(total: number): number | undefined;
    getCurrentPageData(): T[];
    getLocalData(state?: TableState<T> | null): Array<T>;
    prepareParamsArguments(state: any, column?: ColumnProps<T>): any;
    renderPagination(prefixCls: string, paginationPosition: string): JSX.Element | null;
    renderColumnTitle(title: ColumnProps<T>['title']): React.ReactNode;
    renderColumns({ prefixCls, columns }: {
        prefixCls: string;
        columns: ColumnProps<T>[];
    }): any[];
    renderTable: ({ getPrefixCls, renderEmpty }: ConfigConsumerProps) => JSX.Element;
    render(): JSX.Element;
}
export {};
