"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
// import classNames from 'classnames';
var Tab_1 = __importDefault(require("./Tab"));
var TabMeasurer = /** @class */ (function (_super) {
    __extends(TabMeasurer, _super);
    function TabMeasurer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.containerNode = react_1.default.createRef();
        _this.animationFrame = null;
        _this.handleMeasurement = function () {
            if (_this.animationFrame) {
                cancelAnimationFrame(_this.animationFrame);
            }
            _this.animationFrame = requestAnimationFrame(function () {
                if (!_this.containerNode.current) {
                    return;
                }
                var handleMeasurement = _this.props.handleMeasurement;
                var containerWidth = _this.containerNode.current.offsetWidth;
                var hiddenTabNodes = _this.containerNode.current.children;
                var hiddenTabNodesArray = Array.from(hiddenTabNodes);
                var hiddenTabWidths = hiddenTabNodesArray.map(function (node) {
                    return node.getBoundingClientRect().width;
                });
                var showMoreBtnWidth = hiddenTabWidths.pop();
                handleMeasurement({
                    containerWidth: containerWidth,
                    showMoreBtnWidth: showMoreBtnWidth,
                    hiddenTabWidths: hiddenTabWidths,
                });
            });
        };
        return _this;
    }
    TabMeasurer.prototype.componentDidMount = function () {
        this.handleMeasurement();
        window.addEventListener('resize', this.handleMeasurement);
    };
    TabMeasurer.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.tabs !== this.props.tabs) {
            this.handleMeasurement();
        }
    };
    TabMeasurer.prototype.componentWillUnmount = function () {
        window.removeEventListener('resize', this.handleMeasurement);
    };
    TabMeasurer.prototype.render = function () {
        var _a = this.props, prefixCls = _a.prefixCls, tabs = _a.tabs, selected = _a.selected;
        return (react_1.default.createElement("div", { className: prefixCls + "-measure", ref: this.containerNode },
            tabs.map(function (item, i) {
                return (react_1.default.createElement(Tab_1.default, { isSelect: i === selected, key: item.key || item.value, prefixCls: prefixCls, label: item.label, value: item.value, disabled: item.disabled }));
            }),
            react_1.default.createElement("div", { className: prefixCls + "-more visible" })));
    };
    return TabMeasurer;
}(react_1.default.PureComponent));
exports.default = TabMeasurer;
// function noop() {}
//# sourceMappingURL=tabMeasure.js.map